#include "TrafficSignal.h"
#include <UniversalAccessoryDecoder.h>

// le constructeur

TrafficSignal::TrafficSignal(){}


// La mthode du setup

void TrafficSignal::Setup (int Signal2, int Signal3,int DccID, int ledStatusPin, int buttonPin)
{

   // les attributs

   int DccBegin ;
   nbSignal2 = Signal2;			// le nombre de signaux  deux feux
   nbSignal3 = Signal3;			// nombre de signaux  trois feux
   nbSignalTotal = nbSignal2 + nbSignal3 ;
   nbLedTotal = (nbSignal2 * 2) + (nbSignal3 * 3) ;
   IdDcc = DccID;				// code DCC de dpart


  // La bibliothque UAD

    UAD_StartSetup();				// startup de lUAD

// initialisation du DCC

    dcc.Setup(0x00,0x00, KDCC_INTERRUPT);		// le DCC
    dcc.SetStatusLedPin(ledStatusPin);		// sa LED

// Cration du bouton, une action par Led

    button.Setup(1,new ButtonsCommanderPush(nbLedTotal));
    for (int i=0;i<nbSignal2;i++){
                    PUSH(button,0)->AddDccId(IdDcc+i,0);		// vert   DCC/0
                    PUSH(button,0)->AddDccId(IdDcc+i,1);		// rouge DCC/1
                    }

    DccBegin = nbSignal2;
    for (int i=nbSignal2;i<nbSignalTotal;i++){
                    PUSH(button,0)->AddDccId(IdDcc+DccBegin,0);		// vert   DCC/0
                    PUSH(button,0)->AddDccId(IdDcc+DccBegin,1);		// rouge DCC/1
                    PUSH(button,0)->AddDccId(IdDcc+DccBegin+1,0);	  // jaune DCC+1/0
                    DccBegin = DccBegin + 2;
          }


// Association du bouton  sa broche

    PUSH(button,0)->Setup(buttonPin);

//  Les drivers, autant que toutes les leds

    arduino = new DriverArduino(nbLedTotal,0);
    arduino->Setup();

    int port = 0;
    int ledPin = 3;

// Association des ports des drivers aux broches des leds

    for (int i=0;i<nbSignal2;i++){
                    for (int j=0; j<2;j++){arduino->SetupPortMotor(port+j,ledPin+j,DIGITAL);}
                    port = port + 2;
                    ledPin = ledPin + 2;
                    }

    for (int i=nbSignal2;i<nbSignalTotal;i++){
                    for (int j=0; j<3;j++){arduino->SetupPortMotor(port+j,ledPin+j,DIGITAL);}
                    port = port + 3;
                    ledPin = ledPin + 3;
                    }


// La table des accessoires, autant que toutes les leds

leds.Setup(nbLedTotal);

// Cration des accessoires et association aux ports des drivers

port = 0;
for (int i=0;i<nbSignal2;i++){
            leds.Add(new AccessoryLight(1000+i,0));	// vert
            leds.Add(new AccessoryLight(1000+i,1));	// rouge
            LIGHT(leds,port)->Setup(arduino,port);
            LIGHT(leds,port+1)->Setup(arduino,port+1);
            port = port + 2;
            }

DccBegin = nbSignal2;
for (int i=nbSignal2;i<nbSignalTotal;i++){
            leds.Add(new AccessoryLight(1000+DccBegin,0));	// vert
            LIGHT(leds,port)->Setup(arduino,port);
            leds.Add(new AccessoryLight(1000+DccBegin,1));	// rouge
            LIGHT(leds,port+1)->Setup(arduino,port+1);
            leds.Add( new AccessoryLight(1000+DccBegin+1,0));	// jaune
            LIGHT(leds,port+2)->Setup(arduino,port+2);
            port = port + 3;
            DccBegin = DccBegin + 2;
            }

// Cration des groupes daccessoires

signals.Setup(nbLedTotal);

// Gestion des signaux vert

port = 0;
GroupState *green[nbSignalTotal];
for (int i=0;i<nbSignal2;i++){
                green[i] = new GroupState(IdDcc+i,0,false);
                green[i]->Setup(2);
                green[i]->Add(leds[port],LIGHTON);		// vert = ON
                green[i]->Add(leds[port+1],LIGHTOFF);	// rouge = OFF
                port = port + 2;
                signals.Add(green[i]);
                }

DccBegin = nbSignal2;
for (int i=nbSignal2;i<nbSignalTotal;i++) {
                green[i] = new GroupState(IdDcc+DccBegin,0,false);
                green[i]->Setup(3);
                green[i]->Add(leds[port],LIGHTON);		// vert = ON
                green[i]->Add(leds[port+1],LIGHTOFF);	// rouge = OFF
                green[i]->Add(leds[port+2],LIGHTOFF);	// jaune = OFF
                port = port + 3;
                signals.Add(green[i]);
                DccBegin = DccBegin + 2;
                }


// Gestion des signaux rouge

port  = 0;
GroupState *red[nbSignalTotal];
for (int i=0;i<nbSignal2;i++){
                red[i] = new GroupState(IdDcc+i,1,false);
                red [i]->Setup(2);
                red [i]->Add(leds[port],LIGHTOFF);		// vert = OFF
                red [i]->Add(leds[port+1],LIGHTON);		// rouge = ON
                port = port + 2;
                signals.Add(red[i]);
                }

DccBegin = nbSignal2;
for (int i=nbSignal2;i<nbSignalTotal;i++) {
                red [i] = new GroupState(IdDcc+DccBegin,1,false);
                red [i]->Setup(3);
                red [i]->Add(leds[port],LIGHTOFF);		// vert = OFF
                red [i]->Add(leds[port+1],LIGHTON);		// rouge = ON
                red [i]->Add(leds[port+2],LIGHTOFF);	// jaune = OFF
                port = port + 3;
                signals.Add(red [i]);
                DccBegin = DccBegin + 2;
                }

// Gestion des signaux jaune

port = nbSignal2 * 2;
DccBegin = nbSignal2 + 1;
    GroupState *yellow[nbSignal3];
for (int i=nbSignal2;i<nbSignalTotal;i++){
            yellow [i] = new GroupState(IdDcc+DccBegin,0,false);
            yellow [i]->Setup(3);
            yellow [i]->Add(leds[port],LIGHTOFF);		// vert = OFF
            yellow [i]->Add(leds[port+1],LIGHTOFF);		// rouge = OFF
            yellow [i]->Add(leds[port+2],LIGHTON);		// jaune = ON
            port = port + 3;
            DccBegin = DccBegin +2;
            signals.Add(yellow [i]);
    }


UAD_EndSetup(); 	// fin du startup UAD

}

// La mthode loop, on boucle sur tout

void TrafficSignal::Loop() {
if (dcc.Loop()) {
    leds.Loop();
    signals.Loop();
    button.Loop();
    }
}
